#include <direct.h>
#include <dos.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define OUTPUT_PATH_INDEX 1
#define INPUT_FILE_INDEX 2
#define TRADE_EXCEPTIONS_INDEX 3
#define WANTS_OUTPUT_INDEX 4
#define SAI_INDEX 5
#define INTRO_INDEX 6
#define SHORT_INDEX 7

hybrid = 0;
ivory_hybrid = 0;

typedef struct eff {
	struct eff *next;
	char *title;
	char *text;
	int convert_type;
} effect;

typedef struct exc {
	struct exc *next;
	char *race;
	char *name;
	int extra;
	int threshold;
} exception;

typedef struct die {
	struct die *next;
	char *race;
	char *name;
	char *type;
	char *faces;
	char *sort;
	char *outname;
	int sides;
	int size;
	int extra;
	int trade_points;
	int number;
	int threshold;
} dice;

#define ICON_SIZE 50
typedef char icon_type[ICON_SIZE];

#define COLOR_SIZE 100
typedef char color_type[COLOR_SIZE];

#define FALSE 0
#define TRUE !FALSE

#define FILEPATH_SIZE 300
#define LINE_SIZE 1000
#define TEXT_SIZE 20000
#define SIZES_SIZE 10
#define BUFFER_SIZE 200

FILE *ferr;
char errname[FILEPATH_SIZE];
FILE *fin;
FILE *fout;
FILE *fshort;
FILE *fwants;
FILE *feffects;
FILE *flist;
char current_path[FILEPATH_SIZE];
char current_in_path[FILEPATH_SIZE];
char current_exe_path[FILEPATH_SIZE];
icon_type icon[12];
char line[LINE_SIZE],last_line[LINE_SIZE],temp_str[LINE_SIZE],*pos,*pos2,type_name[LINE_SIZE];
char race[BUFFER_SIZE],name[BUFFER_SIZE],type[BUFFER_SIZE],sizes[SIZES_SIZE],faces[BUFFER_SIZE],title[BUFFER_SIZE],text[TEXT_SIZE];
int extra,trade_points,number;
int num[12];
int convert_type;
unsigned int i,j,num_icons;
char date_update[TEXT_SIZE];
char scan_format[BUFFER_SIZE];
char subpageheader[TEXT_SIZE];
char header[TEXT_SIZE];
char **cmd_lines = NULL;
unsigned int num_cmd_lines = 0;
char cmds[BUFFER_SIZE];
char sort;

int wants_column = FALSE;

__time64_t long_time;
struct tm d;

exception *exceptions = NULL;
effect *effects = NULL,*last_effects;
dice *dice_list = NULL,*last_die;

color_type color[24] =  {"","","","","","","","","","","","","","","","","","","","","","","",""};
icon_type number_str[] =  {"zero","one","two","three","four","five","six","seven","eight","nine","ten","eleven","twelve"};

int did_define,output_die_files,output_points,update_die_files,output_form;
int output_faces = TRUE;

char
size_code(int size) {
	if (size == 1) return ('c');
	if (size == 2) return ('u');
	if (size == 3) return ('r');
	if (size == 4) return ('m');
	return('D');
}

double
weight (int size)  {

	if (size == 1) return (0.25);
	if (size == 2) return (0.33);
	if (size == 3) return (0.5);
	if (size == 4) return (0.75);
	return(1);
}

char *
fix_name (char * name) {
	unsigned int i;
	static char ret[1000];

	for (i = 0;i <= strlen(name);i++) {
		switch (name[i]) {
			case ' ':
			case '/':
			case '-':
				ret[i] = '_';
				break;
			default:
				ret[i] = name[i];
				break;
		}
	}
   return(ret);
}

void
open_file (FILE **ffile,const char *filename,const char *mode,const char *err)  {
	char temp_name[FILEPATH_SIZE];

	if (strrchr(filename,'\\') == NULL)  {
		strcpy_s(temp_name,FILEPATH_SIZE,current_path); // look in output path for input files, put in output path for output files
		strcat_s(temp_name,FILEPATH_SIZE,filename);
		if (fopen_s(ffile,temp_name,mode) != 0) {
			if (_getcwd(temp_name, 200) == NULL)  { // next try current working directory
				printf("Can't get current working directory\n");
				fprintf(ferr,"Can't get current working directory\n");
				fclose(ferr);
				exit(2);
			}
			strcat_s(temp_name,FILEPATH_SIZE,filename);
			if (fopen_s(ffile,temp_name,mode) != 0) {
				strcpy_s(temp_name,FILEPATH_SIZE,current_in_path); //  try directory input file was in
				strcat_s(temp_name,FILEPATH_SIZE,filename);
				if (fopen_s(ffile,temp_name,mode) != 0) {
					strcpy_s(temp_name,FILEPATH_SIZE,current_exe_path); // last try directory exe was in
					strcat_s(temp_name,FILEPATH_SIZE,filename);
					if (fopen_s(ffile,temp_name,mode) != 0) {
						printf(err,filename);
						fprintf(ferr,err,filename);
						fclose(ferr);
						exit(2);
				   }
			   }
		   }
	   }
	}
	else {
		if (fopen_s(ffile,filename,mode) != 0) { // got full path name, use it
			printf(err,filename);
			fprintf(ferr,err,filename);
			fclose(ferr);
			exit(2);
	   }
	}
}

void
init_file_open(char *exe_filename, char *output_filename, char *input_filename) {
	char *pos;

	strcpy_s(cmds,BUFFER_SIZE,input_filename);
	strcpy_s(current_exe_path,FILEPATH_SIZE,exe_filename);
	if ((pos = strrchr(current_exe_path,'\\')) != NULL)
		*(++pos) = '\0';
	else
		if ((pos = strrchr(current_exe_path,':')) != NULL)
			*(++pos) = '\0';
		else
			current_exe_path[0] = '\0';
	strcpy_s(current_path,FILEPATH_SIZE,output_filename);
	if ((pos = strrchr(current_path,'\\')) != NULL)
		*(++pos) = '\0';
	else
		if ((pos = strrchr(current_path,':')) != NULL)
			*(++pos) = '\0';
		else
			current_path[0] = '\0';
	strcpy_s(current_in_path,FILEPATH_SIZE,input_filename);
	if ((pos = strrchr(current_in_path,'\\')) != NULL)
		*(++pos) = '\0';
	else
		if ((pos = strrchr(current_in_path,':')) != NULL)
			*(++pos) = '\0';
		else
			current_in_path[0] = '\0';
	if (strrchr(input_filename,'\\') == NULL)  {
		if (_getcwd(errname,200) == NULL)  {
			printf("Can't get current working directory\n");
			exit(2);
		}
		strcat_s(errname,FILEPATH_SIZE,input_filename);
	}
	else
		strcpy_s(errname,FILEPATH_SIZE,input_filename);
	if ((pos = strrchr(errname,'.')) != NULL)
		*(pos) = '\0';
	strcat_s(errname,FILEPATH_SIZE,".ERR");
	if (fopen_s(&ferr,errname,"wt")!= 0) {
		printf("Can't open error log file %s\n",errname);
		exit(255);
	}
}

void
new_exceptions (char *race, char *name, int threshold, int extra)  {
	exception *temp;

	if ((temp = malloc(sizeof(exception))) == NULL) {
		printf("\nMemory error!\n");
		fprintf(ferr,"\nMemory error!\n");
		fclose(ferr);
		exit(2);
	}
	(*temp).next = exceptions;
	exceptions = temp;
	(*temp).race = _strdup(race);
	(*temp).name = _strdup(name);
	(*temp).threshold = threshold;
	(*temp).extra = extra;
}

int
convert_size (char *size) {

	switch (size[0]) {
		case '1':
			if (strcmp(size,"10") == 0)
				return(5);
			else
				return(1);
		case '2':
			return(2);
		case '3':
			return(3);
		case '4':
			return(4);
		case '5':
			return(5);
		case 'm':
			return(6);
		case 'T':
			return(7);
	}
	return(0);
}

int extra_table[] =  {
1,    // unknown??
10,		// commons
5,		// uncommons
2,		// rares
1,		// monsters
1,		// dragons
2,		// minor terrians
2		// major terrains
};

void
extra_exceptions(dice *die, int extra)  {
	exception *temp;
	int value;
	int threshold;
	char *race;
	char *name;
	int size;

	race = die->race;
	name = die->name;
	size = die->size;
	temp = exceptions;
	while ((temp != NULL) && ((_stricmp((*temp).race,race) != 0) || (_stricmp((*temp).name,name) != 0))) {
		temp = (*temp).next;
	}

	if (temp != NULL)
		if (temp->threshold == -1) {
			die->extra = 0;
			die->threshold = 0;
			return;
		}
		else if (temp->threshold == -2) {
			die->extra = -3000;
			die->threshold = 0;
			return;
		}
		else
			threshold = temp->threshold;
	else
		threshold = extra_table[size];

	if ((
		 (extra < 0)
		 ||
		 (
		  (strstr(race,"Item") != NULL)
		  &&
		  (extra > 1)
		 )
		 ||
		 (extra >= threshold)
		) &&
		(threshold >= 0)
		)
		value = extra;
	else  {
		if (threshold == -3) {
			die->extra = 0;
			die->threshold = 0;
			return;
		}
		else if (extra > 0)
			value = extra + 1000;
		else
			if (threshold == 0)
				value = -2000;
			else
				value = -1000;
		new_exceptions(race,name,threshold,extra);
	}
	if ((fwants != NULL) && (value < 0) && (value > -1000))  {
		if (wants_column)
			fprintf(fwants,"<TR>");
		fprintf(fwants,"<TD>");
		if (value == -1)
			fprintf(fwants,"%s - %s",race,name);
		else
			fprintf(fwants,"%s - %s (%d)",race,name,abs(value));
		fprintf(fwants,"</TD>");
		wants_column = !wants_column;
		if (wants_column)
			fprintf(fwants,"</TR>\n");
	}
	die->extra = value;
	die->threshold = threshold;
}

char *
trade_color(int extra)  {
	if (extra == -3000) return("#808000");
	if (extra < -1000) return("#000000");
	if ((extra < 0) || (extra > 1000)) return("#FF0000");
	if (extra > 0) return("#22B022");
	return("#000000");
}

char *
extra_convert(int extra)  {
	static char temp[BUFFER_SIZE];

	if (extra == -3000)
		sprintf_s(temp,BUFFER_SIZE,"<B>Not Made Yet</B>");
	else if (extra == -1000)
		sprintf_s(temp,BUFFER_SIZE,"***");
	else if ((extra == 0) || (extra < -1000))
		sprintf_s(temp,BUFFER_SIZE,"N/A");
	else if (extra < 0)
		sprintf_s(temp,BUFFER_SIZE,"Want %d",abs(extra));
	else if (extra > 1000)
		sprintf_s(temp,BUFFER_SIZE,"Extra %d",abs(extra - 1000));
	else if (extra > 0)
		sprintf_s(temp,BUFFER_SIZE,"Extra %d",abs(extra));
	return(temp);
}

char *
size_string(int size, int sides)  {

	if (size == 1) return ("Small");
	if (size == 2) return ("Medium");
	if (size == 3) return ("Large");
	if ((size == 4) && (sides == 10)) return ("Monster");
	if ((size == 4) && (sides == 6)) return ("Champion");
	return("");
}

char *
type_number(char *type,int size) {
	static int old_size = 0;
	static int types[5] = {0,0,0,0,0};
	static char buffer[3];
	int i = 0;

	if (size != old_size) {
		for(i = 0;i < 5;i++) {
			types[i] = 0;
		}
		old_size = size;
		i = 0;
	}
	if (strcmp(type,"Archer") == 0) i = types[0]++;
	if (strcmp(type,"Heavy Troop") == 0) i = types[1]++;
	if (strcmp(type,"Light Troop") == 0) i = types[2]++;
	if (strcmp(type,"Cavalry") == 0) i = types[3]++;
	if (strcmp(type,"Mage") == 0) i = types[4]++;
	sprintf_s(buffer,3,"%d",i);
	return(buffer);
}

char *
get_tok (char *text)  {
	char *pos,*context;
	static char temp_str[LINE_SIZE];
	int i;

	pos = strtok_s(text,"$",&context);
	i = 0;
  	strcpy_s(temp_str,LINE_SIZE,pos);
	while ((pos = strtok_s(NULL,"$",&context)) != NULL) {
		strcpy_s(color[i++],COLOR_SIZE,pos);
		if ((_stricmp(temp_str,"ID") == 0) &&
		    (_stricmp(pos,"black") == 0)) {
			strcpy_s(temp_str,LINE_SIZE,"ID_BLACK");
		}
		if ((_strnicmp(temp_str,"EL",2) == 0) &&
		    (_stricmp(pos,"black") == 0)) {
			strcpy_s(temp_str,LINE_SIZE,"EL_BLACK");
		}
	}
	return(temp_str);
}

typedef struct rsl {
	char full_name[30];
	char short_name[3];
} race_short_lookup;

race_short_lookup race_short[] = {
{"Amazons","am"},
{"Coral Elves","co"},
{"Dwarves","dw"},
{"Eldarim","el"},
{"Eldarim-Black","be"},
{"Eldarim-Blue","ce"},
{"Eldarim-Gold","ge"},
{"Eldarim-Green","he"},
{"Eldarim-Red","re"},
{"Ferals","fe"},
{"Firewalkers","fi"},
{"Frostwings","fr"},
{"Frostwings(promos)","f1"},
{"Frostwings(reprints)","f2"},
{"Goblins","go"},
{"Lava Elves","la"},
{"Scalders","sc"},
{"Scalders(promos)","s1"},
{"Scalders(reprints)","s2"},
{"Swamp Stalkers","sw"},
{"Treefolk","tr"},
{"Undeads","un"},
{"Items","ma"},
{"Dragonkin","dr"},
{"MISPRINTS","mi"},
{"PROMOS","pr"},
{"Terrains","te"},
{"",""}
};

char *
return_race_short(char *race) {
	int i = 0;

	while ((_stricmp(race_short[i].full_name,race) != 0) && (strlen(race_short[i].full_name) > 0)) {
		i++;
	}
	return(race_short[i].short_name);
}

char *
look_up(char *title, int num, int err) {

	effect *temp;
	static char temp_str[TEXT_SIZE];
   char temp_search[TEXT_SIZE];

   if (title == NULL) return(NULL);
	temp = effects;
	sprintf_s(temp_search,TEXT_SIZE,"%s_%d",title,num);
	while (
		   (temp != NULL)
		   &&
		   (_stricmp((*temp).title,temp_search) != 0)
		   &&
           (_stricmp((*temp).title,title) != 0)
		  ) {
		temp = (*temp).next;
	}
	if (temp == NULL) {
		if (err)
			fprintf(ferr,"%s not found\n",title);
		if (err == 2) {
			fclose(ferr);
//			exit(5);
		}
		return(NULL);
	}
	strcpy_s(temp_search,TEXT_SIZE,(*temp).text);
	if (num == 0)  {
		if ((_strnicmp(temp_search,"ID",2) == 0) || (_strnicmp(temp_search,"EL",2) == 0))  {
			strcpy_s(temp_str,TEXT_SIZE,title);
		}
		else {
			return(get_tok(temp_search));
		}
	}
	else if (strchr(temp_search,'$') != NULL)  {
		return(get_tok(temp_search));
	}
	else {
		switch ((*temp).convert_type) {
			case 1:
				sprintf_s(temp_str,TEXT_SIZE,(*temp).text,number_str[num],number_str[num],number_str[num],number_str[num],number_str[num],number_str[num],number_str[num],number_str[num]);
				break;
			case 2:
				fprintf(ferr,"No such options in effect.txt allowed (2)\n");
				break;
			case 3:
				sprintf_s(temp_str,TEXT_SIZE,(*temp).text,color[0],color[0]);
				break;
			case 4:
				sprintf_s(temp_str,TEXT_SIZE,(*temp).text,number_str[num],color[0],color[0]);
				break;
			case 5:
				sprintf_s(temp_str,TEXT_SIZE,(*temp).text,color[0],color[1]);
				break;
			case 6:
				sprintf_s(temp_str,TEXT_SIZE,(*temp).text,number_str[num],color[0],color[1]);
				break;
			case 0:
			default:
				strcpy_s(temp_str,TEXT_SIZE,(*temp).text);
				break;
		}
	}
	return(temp_str);
}

char *
remove_junk( char *name, int size)  {
	char line[LINE_SIZE];
	size_t i;

	strcpy_s(line,LINE_SIZE,name);
	while (( i = strcspn(line," `~!@#$%^&*()-=+[]{};':,.|<>?'/\"\\")) != strlen(line)) {
     	line[i] = '_';
	}
	strcpy_s(name,size,line);
	_strlwr_s(name,size);
	return(name);
}

char *
size_char (int size) {
	static char size_string[SIZES_SIZE];

	sprintf_s(size_string,SIZES_SIZE,"%d",size);
	return(size_string);
}

int
jpg_size_h (char *race,int size)  {
   char temp_search[LINE_SIZE],*pos;
	int num;

	strcpy_s(temp_search,LINE_SIZE,race);
	strcat_s(temp_search,LINE_SIZE,size_char(size));
	if ((pos = look_up(temp_search,10,1)) == NULL)  {
		printf("JPG size not found for %s, %d\n",race,size);
		fprintf(ferr,"JPG size not found for %s, %d\n",race,size);
		fclose(ferr);
		exit(6);
	}
	sscanf_s(pos,"%d %*d",&num);
	return(num);
}

int
jpg_size_w (char *race,int size)  {
   char temp_search[LINE_SIZE],*pos;
	int num;

	strcpy_s(temp_search,LINE_SIZE,race);
	strcat_s(temp_search,LINE_SIZE,size_char(size));
	if ((pos = look_up(temp_search,10,1)) == NULL)  {
		printf("JPG size not found for %s, %d\n",race,size);
		fprintf(ferr,"JPG size not found for %s, %d\n",race,size);
		fclose(ferr);
		exit(6);
	}
	sscanf_s(pos,"%*d %d",&num);
	return(num);
}

void
get_effects (const char *filename)  {
	int stat;

	open_file(&feffects,filename,"rt","Can't open effects file %s\n");
	while((stat = fscanf_s(feffects,"%[^\n]\n%d\n%[^~]~\n",title,BUFFER_SIZE,&convert_type,text,TEXT_SIZE)) == 3) {
		effect *temp;

		if ((temp = malloc(sizeof(effect))) == NULL) {
			printf("\nMemory error!\n");
			fprintf(ferr,"\nMemory error!\n");
			fclose(ferr);
			exit(2);
		}
		if (effects == NULL)
			effects = temp;
		else
			last_effects->next = temp;
		last_effects = temp;
		temp->title = _strdup(title);
		text[strlen(text)-1] = '\0';
		temp->text = _strdup(text);
		temp->convert_type = convert_type;
	}
	if (stat == 0)  {
		printf("\nError in format of file %s\n",filename);
		fprintf(ferr,"\nError in format of file %s\n",filename);
		fclose(ferr);
		exit(2);
	}
	last_effects->next = NULL;
	fclose(feffects);
}

void
get_exceptions (const char *filename)  {
	int threshold;

	open_file(&feffects,filename,"rt","Can't open effects file %s\n");
	fscanf_s(feffects,"%[^|]|\n",date_update,TEXT_SIZE);
	while(fscanf_s(feffects,"\"%[^\"]\", \"%[^\"]\", %d\n",race,BUFFER_SIZE,name,BUFFER_SIZE,&threshold) == 3) {
	   new_exceptions(race,name,threshold,0);
	}
	fclose(feffects);
}

void
bottom_of_page(void) {

	if (!output_die_files)
		return;

	fprintf(fout,"<CENTER>Click on the <A HREF=\"help.html\" TARGET=\"body\">die name</A> above to get more information about each die.</CENTER>");
	fprintf(fout,"<CENTER>Use positive numbers to get dice. Use negative numbers to give dice to me.</CENTER>\n");
}

#define EMAIL_COLUMNS 4

void
write_out_refs(void) {
	char name[80];
	char email[80];
	int i = 0;

	fprintf(fout,"<HTML>\n<HEAD>\n");
	fprintf(fout,"<script TYPE=\"text/javascript\" SRC=\"ref.jar\" LANGUAGE=\"JavaScript\"></script>\n");
	fprintf(fout,"</HEAD>\n<BODY onload=\"do_frame('dragondice',0)\">\n");
	fprintf(fout,"<H3>Trade References:</H3>\n");
	fprintf(fout,"<TABLE WIDTH=\"100%%\" BORDER=0>\n");
	while (fscanf_s(fin,"%[^\t] %s\n",name,80,email,80) == 2) {
		if ((i % EMAIL_COLUMNS) == 0)	 {
			fprintf(fout,"<TR>\n");
		}
		fprintf(fout,"<TD><script language=\"javascript\" type=\"text/javascript\">emailfull(\"%s\",\"%s\",\"%s\",\"%s\")</script></TD>\n",email,name);
		if ((i++ % EMAIL_COLUMNS) == (EMAIL_COLUMNS - 1)) {
			fprintf(fout,"</TR>\n");
		}
	}
	fprintf(fout,"</TR>\n</TABLE>\n");
	fprintf(fout,"<P><A HREF=\"bad.html\" TARGET=\"body\">Bad Traders</A>.\n");
	fprintf(fout,"<P>\n");
	fprintf(fout,"If your email address is wrong, please fill out this form and send to me.\n");
	fprintf(fout,"<FORM name=\"ref\" METHOD=\"POST\" ACTION=\"m&#97;ilt&#111;:web1&#64;chuckpint&#46;com\" TITLE=\"Trade references update\" ENCTYPE=\"text/plain\">");
	fprintf(fout,"<strong>Your Name:</strong> (Required)");
	fprintf(fout,"<input type=text name=\"realname\" onChange=\"saveValue(this)\"><BR>");
	fprintf(fout,"<strong>Your E-Mail:</strong> (Required)");
	fprintf(fout,"<input type=text name=\"email\" onChange=\"saveValue(this)\"><BR>");
	fprintf(fout,"<input TYPE=\"submit\" VALUE=\"Click here to send.\">");
	fprintf(fout,"</FORM>\n");
	fprintf(fout,"</BODY>\n");
	fprintf(fout,"</HTML>\n");
}

int
specials(dice *temp) {

	if (_strnicmp(temp->sort,"Te",2) != 0)
		return 0;
	if (strstr(temp->sort,"Castle") != NULL)
		return 1;
	if (strstr(temp->sort,"Dragon Lair") != NULL)
		return 1;
	if (strstr(temp->sort,"Grove") != NULL)
		return 1;
	if (strstr(temp->sort,"Vortex") != NULL)
		return 1;
	return 0;
}

int
main(unsigned int argc, char *argv[]) {
	int size;

	if (argc < 3) {
		init_file_open("\\dragon dice assistant\\ddhtml\\Debug\\ddhtml.exe","\\Website\\","\\Dragon Dice\\data\\dd.cmds");
	}
	else {
		init_file_open(argv[0],argv[1],argv[2]);
	}
	//parse command line
	open_file(&fin,cmds,"rt","Can't open source file %s\n");
	while (fgets(line,1000,fin) != NULL) {
		if ((cmd_lines = realloc(cmd_lines,(++num_cmd_lines) * sizeof(char *))) == NULL) {
			fprintf(ferr,"Memory error!\n");
			fclose(ferr);
			return(1);
		}
		line[strlen(line) - 1] = '\0';
		cmd_lines[num_cmd_lines - 1] = _strdup(line);
	}
	fclose(fin);
	fshort = NULL;
	fwants = NULL;
	output_points = did_define = output_die_files = output_form = update_die_files = FALSE;
	trade_points = 0;
	strcpy_s(faces,BUFFER_SIZE,"");
	strcpy_s(header,TEXT_SIZE,"");
	_time64( &long_time );
	_localtime64_s(&d,&long_time); //getdate(&d);

	//parse command line
	for (i = 1;i < num_cmd_lines;i++) {
		if (cmd_lines[i][0] == '$')
			continue;
		if ((cmd_lines[i][0] != '/') && (cmd_lines[i][2] != ':')) {
			printf("Badly formed option %s\n",cmd_lines[i]);
			fprintf(ferr,"Badly formed option %s\n",cmd_lines[i]);
			fclose(ferr);
			exit(3);
		}
		switch (cmd_lines[i][1]) {
			case 'D':
			case 'd':
				get_effects(&cmd_lines[i][3]);
				did_define = TRUE;
				break;
			case 'E':
			case 'e':
				get_effects(&cmd_lines[i][3]);
				output_die_files = TRUE;
				break;
			case 'F':
			case 'f':
				output_form = TRUE;
				break;
			case 'H':
			case 'h':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				fscanf_s(fin,"%[^|]",header,TEXT_SIZE);
				fclose(fin);
				break;
			case 'I':
			case 'i':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				strcpy_s(line,LINE_SIZE,&cmd_lines[i][3]);
				pos = strrchr(line,'.');
				*pos = '\0';
				strcat_s(line,LINE_SIZE,".html");
				open_file(&fout,line,"wt","Can't open output file %s\n");
				fscanf_s(fin,"%[^~]",date_update,TEXT_SIZE);
				fprintf(fout,date_update,d.tm_mon+1,d.tm_mday,d.tm_year+1900);
				fclose(fin);
				fclose(fout);
				break;
			case 'P':
			case 'p':
				output_points = TRUE;
				break;
			case 'R':
			case 'r':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				strcpy_s(line,LINE_SIZE,&cmd_lines[i][3]);
				pos = strrchr(line,'.');
				*pos = '\0';
				strcat_s(line,LINE_SIZE,".html");
				open_file(&fout,line,"wt","Can't open output file %s\n");
				write_out_refs();
				fclose(fin);
				fclose(fout);
				break;
			case 'S':
			case 's':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				strcpy_s(line,LINE_SIZE,&cmd_lines[i][3]);
				pos = strrchr(line,'.');
				*pos = '\0';
				strcat_s(line,LINE_SIZE,".html");
				open_file(&fshort,line,"wt","Can't open output file %s\n");
				fscanf_s(fin,"%[^|]",date_update,TEXT_SIZE);
				fprintf(fshort,date_update,d.tm_mon+1,d.tm_mday,d.tm_year+1900);
				fclose(fin);
				break;
			case 'T':
			case 't':
				get_exceptions(&cmd_lines[i][3]);
				break;
			case 'U':
			case 'u':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				fscanf_s(fin,"%[^|]",subpageheader,TEXT_SIZE);
				fclose(fin);
				update_die_files = TRUE;
				break;
			case 'V':
			case 'v':
				strcpy_s(line,LINE_SIZE,current_path);
				strcat_s(line,LINE_SIZE,"list.html");
				open_file(&flist,line,"wt","Can't open list output file %s\n");
				break;
			case 'W':
			case 'w':
				open_file(&fin,&cmd_lines[i][3],"rt","Can't open source file %s\n");
				strcpy_s(line,LINE_SIZE,&cmd_lines[i][3]);
				pos = strrchr(line,'.');
				*pos = '\0';
				strcat_s(line,LINE_SIZE,".html");
				open_file(&fwants,line,"wt","Can't open output file %s\n");
				fscanf_s(fin,"%[^|]",date_update,TEXT_SIZE);
				fprintf(fwants,date_update);
				fclose(fin);
				wants_column = FALSE;
				break;
			default :
				printf("Unknown option %s\n",cmd_lines[i]);
				fprintf(ferr,"Unknown option %s\n",cmd_lines[i]);
				fclose(ferr);
				exit(3);
				break;
		}
	}

	if (!did_define) get_effects("ddhtml.txt");

	open_file(&fin,cmd_lines[0],"rt","Can't open source file %s\n");

	if ((!output_die_files && update_die_files))  {
		printf("Can not have die file output or update without effects file loaded.\n");
		fprintf(ferr,"Can not have die file output or update without effects file loaded.\n");
		fclose(ferr);
		exit(3);
	}

	while(fscanf_s(fin,"\"%[^\"]\", \"%[^\"]\", \"%[^\"]\", \"%[^\"]\", %d, %d, %d, \"%[^\"]\"\n",race,BUFFER_SIZE,name,BUFFER_SIZE,type,BUFFER_SIZE,sizes,SIZES_SIZE,&extra,&trade_points,&number,faces,BUFFER_SIZE) == 8) {
		dice *temp;

		if ((temp = malloc(sizeof(dice))) == NULL) {
			printf("\nMemory error!\n");
			fprintf(ferr,"\nMemory error!\n");
			fclose(ferr);
			return(1);
		}
		temp->size = convert_size(sizes);
		if (temp->size == 5)
			temp->race = "Wyrms";
		else
			temp->race = _strdup(race);
		temp->name = _strdup(name);
		temp->type = _strdup(type);
		extra_exceptions(temp,extra);
		temp->trade_points = trade_points;
		temp->number = number;
		temp->faces = _strdup(faces);
		pos = faces;
		for (size = 1;(pos = strchr(pos,',')) != NULL;size++) {
			pos = pos + 1;
		}
		if (size < 4) size = 8;
		temp->sides = size;
		strcpy_s(color[0],COLOR_SIZE,"");
		pos = look_up(temp->race,9,2);
		if (_strnicmp(pos,"ID",2) == 0) {
			strcpy_s(line,LINE_SIZE,"A");
			strcat_s(line,LINE_SIZE,return_race_short(race));
			line[3] = '\0';
			strcat_s(line,LINE_SIZE,size_char(temp->size));
			if (type[0] == '(')
				strcat_s(line,LINE_SIZE,name);
			else
				strcat_s(line,LINE_SIZE,type);
		}
		else if (_strnicmp(pos,"EL",2) == 0) {
			strcpy_s(line,LINE_SIZE,"A");
			strcat_s(line,LINE_SIZE,return_race_short(race));
			line[3] = '\0';
			strcat_s(line,LINE_SIZE,size_char(temp->size));
			strcat_s(line,LINE_SIZE,type_number(temp->type,temp->size));
			if (type[0] == '(')
				strcat_s(line,LINE_SIZE,name);
			else
				strcat_s(line,LINE_SIZE,type);
		}
		else {
			strcpy_s(line,LINE_SIZE,pos);
			strcat_s(line,LINE_SIZE,size_char(temp->size));
			if (type[0] == '(')
				if ((temp->size > 3) && (strlen(color[0]) != 0))
					if ((pos = strstr(name,"Dragon")) != NULL) {
						if (_strnicmp(pos,"dragonkin",9) == 0)
							strcat_s(line,LINE_SIZE,"Z");
						else if (pos == name)
							strcat_s(line,LINE_SIZE,"K");
						else {
							pos += strlen("Dragon");
							if (_strnicmp(pos,"hu",2) == 0)
								strcat_s(line,LINE_SIZE,"1");
							else if (_strnicmp(pos,"ma",2) == 0)
								strcat_s(line,LINE_SIZE,"2");
							else
								strcat_s(line,LINE_SIZE,"K");
						}
					}
					else
						strcat_s(line,LINE_SIZE,color[0]);
				else {
					if (temp->size >= 5)
						strcpy_s(line,LINE_SIZE,"Wyrm");
					if (strchr(race,'/') != NULL) {
						pos = strrchr(race,'-') + 1;
						if (_strnicmp(pos,"ivory",5) == 0)
							strcat_s(line,LINE_SIZE,"xx");
						else
							strcat_s(line,LINE_SIZE,"zz");
					}
					strcat_s(line,LINE_SIZE,name);
					if (temp->size >= 5)
						strcat_s(line,LINE_SIZE,"_");

				}
			else
				strcat_s(line,LINE_SIZE,type);
			strcpy_s(temp_str,LINE_SIZE,race);
//			if ((pos2 = strchr(temp_str,' ')) != NULL)
//				*pos2 = '\0';
			strcat_s(line,LINE_SIZE,temp_str);
		}
		temp->sort = _strdup(line);
		if ((dice_list == NULL) || (_stricmp((*dice_list).sort,line) > 0)) {
				temp->next = dice_list;
				dice_list = temp;
		}
		else {
			last_die = dice_list;
			while ((last_die->next != NULL) && (_stricmp((*last_die->next).sort,line) < 0)) {
				last_die = last_die->next;
			}
			temp->next = last_die->next;
			last_die->next = temp;
		}
 	}
	if (output_die_files) {
		dice *temp;
		
		temp = dice_list;
		while (temp != NULL) {
			strcpy_s(name,BUFFER_SIZE,temp->name);
			strcpy_s(race,BUFFER_SIZE,temp->race);
			strcpy_s(faces,BUFFER_SIZE,temp->faces);
			remove_junk(name,BUFFER_SIZE);
			pos = look_up(race,0,2);
			strcpy_s(race,BUFFER_SIZE,pos);
			strcpy_s(line,LINE_SIZE,return_race_short(race));
			line[2] = '\0';
			strcat_s(line,LINE_SIZE,"_");
			strcat_s(line,LINE_SIZE,name);
			strcat_s(line,LINE_SIZE,".html");
			temp->outname = _strdup(line);
			if (update_die_files && (strcmp(line,last_line) != 0)) {
				open_file(&fout,line,"wt","Can't open output file %s\n");
				strcpy_s(last_line,LINE_SIZE,line);
				if (_strnicmp(race,"te",2) == 0) {
					strcpy_s(line,LINE_SIZE,temp->name);
					if (temp->size == 6)
						strcat_s(line,LINE_SIZE," faceslookup");
					strcpy_s(faces,BUFFER_SIZE,look_up(line,0,2));
				}
				num_icons = sscanf_s(faces,"%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,],%d %[^,]",
									&num[0],icon[0],ICON_SIZE,&num[1],icon[1],ICON_SIZE,&num[2],icon[2],ICON_SIZE,&num[3],icon[3],ICON_SIZE,
									&num[4],icon[4],ICON_SIZE,&num[5],icon[5],ICON_SIZE,&num[6],icon[6],ICON_SIZE,&num[7],icon[7],ICON_SIZE,
									&num[8],icon[8],ICON_SIZE,&num[9],icon[9],ICON_SIZE,&num[10],icon[10],ICON_SIZE,&num[11],icon[11],ICON_SIZE);
				num_icons = num_icons / 2;
				fprintf(fout,"%s<BODY onload=\"do_frame('dragondice',0)\">\n",subpageheader);
				if (_strnicmp(race,"te",2) == 0) {
					strncpy_s(line,LINE_SIZE,temp->sort,9);
				} else {
					strcpy_s(line,LINE_SIZE,race);
				}
				remove_junk(line,LINE_SIZE);
				fprintf(fout,"<CENTER><B><A HREF=\"%s.html\" TARGET=\"body\">%s</A></B></CENTER><BR>\n",line,temp->name);
				for (i = 0;i < 24;i++) {
					strcpy_s(color[i],COLOR_SIZE,"");
				}
				for (i = 0;i < num_icons;i++) {
					if ((num[i] != 8) && (_stricmp(race,"terrains") == 0)) {
						strcat_s(icon[i],ICON_SIZE, (temp->size == 6) ? " Minor" : " Terrain");
					}
					if ((i == 0) || (_strnicmp(icon[i],"ID",2) == 0))  { // special processing for ID
						pos = look_up(temp->race,num[i],2);
						strcpy_s(type_name,LINE_SIZE,pos);
						if (((_strnicmp(type_name,"ID",2) == 0) && (_strnicmp(icon[i],"ID",2) != 0)) ||
						    ((_strnicmp(type_name,"EL",2) == 0) && (_strnicmp(icon[i],"ID",2) != 0))) {
	              			strcpy_s(text,TEXT_SIZE,icon[i]);
		                    strcat_s(text,TEXT_SIZE,&type_name[2]);
							pos2 = look_up(text,num[i],2);
							strcpy_s(text,TEXT_SIZE,pos2);
							strcpy_s(line,LINE_SIZE,return_race_short(race));
							strcat_s(line,LINE_SIZE,"_");
							strcat_s(line,LINE_SIZE,name);
							strcat_s(line,LINE_SIZE,"_id");
							strcpy_s(type_name,LINE_SIZE,race);
	              		}
						else if ((pos2 = look_up(type_name,num[i],0)) == NULL) {
							if (_stricmp(color[1],"name") == 0) {
								strcpy_s(type_name,LINE_SIZE,name);
							}
							strcpy_s(temp_str,LINE_SIZE,icon[i]);
							if (_strnicmp(temp_str,"ID",2) == 0){
								if (_strcmpi(temp_str,"ID(kin)") != 0)  {
									if (_stricmp(color[1],"black") == 0) {
										if (_strnicmp(type_name,"EL",2) == 0)
											strcpy_s(temp_str,LINE_SIZE,"EL_BLACK");
										else
											strcpy_s(temp_str,LINE_SIZE,"ID_BLACK");
									}
									else if ((strlen(color[1]) == 0) || (_stricmp(color[1],"name") == 0))  {
										if (_stricmp(color[0],"black") == 0) {
											if (_strnicmp(type_name,"EL",2) == 0)
												strcpy_s(temp_str,LINE_SIZE,"EL_BLACK");
											else
												strcpy_s(temp_str,LINE_SIZE,"ID_BLACK");
										}
										else if (_stricmp(color[0],"white") == 0) {
											strcpy_s(temp_str,LINE_SIZE,"ID_WHITE");
										}
										else {
											if (_strnicmp(type_name,"EL",2) == 0)
												strcpy_s(temp_str,LINE_SIZE,"EL_COLOR");
											else
												strcpy_s(temp_str,LINE_SIZE,"ID_COLOR");
										}
									}
									if (_stricmp(race,"terrains") == 0) {
										strcpy_s(type_name,LINE_SIZE,name);
										pos = strchr(type_name,'_');
										*pos = '\0';
										strcpy_s(temp_str,LINE_SIZE,"ID_MINOR");
									}
								}
								pos2 = name;
							}
							else {
			         			if (_stricmp(race,"terrains") == 0) {
			         				strcpy_s(type_name,LINE_SIZE,name);
									pos = strchr(type_name,'_');
									*pos = '\0';
		         				}
			         			if (temp->size == 5) {
			         				strcpy_s(type_name,LINE_SIZE,name);
			         			}
								pos2 = type_name;
							}
							remove_junk(type_name,LINE_SIZE);
							strcpy_s(line,LINE_SIZE,pos2);
							strcpy_s(text,TEXT_SIZE,look_up(temp_str,(num[i] == 0) ? 10 : num[i],2));
							if (specials(temp))
								strcat_s(line,LINE_SIZE,"8");
							else
								strcat_s(line,LINE_SIZE,size_char(temp->size));
							strcat_s(line,LINE_SIZE,"_");
							strcpy_s(temp_str,LINE_SIZE,icon[i]);
							strcat_s(line,LINE_SIZE,temp_str);
							sprintf_s(temp_str,LINE_SIZE,"%d",num[i]);
							strcat_s(line,LINE_SIZE,temp_str);
							if (i != 0) {
								fprintf(fout,"<BR>\n");
								strcat_s(line,LINE_SIZE,"2");
							}
						}
						else {
							strcpy_s(text,TEXT_SIZE,pos2);
		         			if (temp->size == 5)
		         				strcpy_s(line,LINE_SIZE,name);
		         			else {
								strcpy_s(line,LINE_SIZE,return_race_short(race));
								line[2] = '\0';
								strcat_s(line,LINE_SIZE,"_");
								strcat_s(line,LINE_SIZE,name);
								strcat_s(line,LINE_SIZE,"_id");
							}
							strcpy_s(type_name,LINE_SIZE,race);
						}
					}
					else {
						fprintf(fout,"<BR>\n");
						strcpy_s(text,TEXT_SIZE,look_up(icon[i],(num[i] == 0) ? 10 : num[i],2));
						strcpy_s(line,LINE_SIZE,type_name);
						if ((temp->size == 4) && (strstr(temp->race,"Eldarim") != NULL))
							strcat_s(line,LINE_SIZE,temp->name);
						else if (specials(temp))
							strcat_s(line,LINE_SIZE,"8");
						else
							strcat_s(line,LINE_SIZE,size_char(temp->size));
						strcat_s(line,LINE_SIZE,"_");
						strcpy_s(temp_str,LINE_SIZE,icon[i]);
						strcat_s(line,LINE_SIZE,temp_str);
						sprintf_s(temp_str,LINE_SIZE,"%d",num[i]);
						strcat_s(line,LINE_SIZE,temp_str);
						if ((temp->size != 4) && (strstr(temp->race,"Eldarim") != NULL)) {
							sprintf_s(temp_str,LINE_SIZE,"%c",temp->name[0]);
							strcat_s(line,LINE_SIZE,temp_str);					
							if (temp->size != 1) {
								sprintf_s(temp_str,LINE_SIZE,"%c",temp->sort[4]);
								strcat_s(line,LINE_SIZE,temp_str);
							}
						}
					}
					remove_junk(line,LINE_SIZE);
					fprintf(fout,"<IMG ALT=\"%s\" SRC=\"images/%s.jpg\" ALIGN=\"left\" HEIGHT=%d WIDTH=%d>\n",icon[i],line,jpg_size_h(temp->race,temp->size),jpg_size_w(temp->race,temp->size));
					fprintf(fout,"%s: %s\n<BR CLEAR=left>\n",icon[i],text);
				}
				if (_strnicmp(race,"te",2) == 0) {
					strncpy_s(line,LINE_SIZE,temp->sort,9);
				} else {
					strcpy_s(line,LINE_SIZE,race);
				}
				fprintf(fout,"<CENTER><B><A HREF=\"%s.html\" TARGET=\"body\">Back</A></B></CENTER>\n</BODY>\n</HTML>\n",remove_junk(line,LINE_SIZE));
				fclose(fout);
			}
			temp = temp->next;
		}
	}
	if (fwants != NULL)  {
		exception *last_die;

		if (!wants_column)
			fprintf(fwants,"<TD></TD></TR>\n");
		fprintf(fwants,"</TABLE>\n");
		fprintf(fwants,"<P>\n<H1>Dice I will take in trade</H1>\n");
		fprintf(fwants,"<TABLE BORDER=0 CELLSPACING=\"1\" CELLPADDING=\"1\" WIDTH=\"100%%\">\n");
		wants_column = TRUE;
		last_die = exceptions;
		while (last_die != NULL) {
			if ((last_die->extra >= 0) && (last_die->threshold > 0) && (last_die->threshold < 2000)) {
				if (wants_column)
					fprintf(fwants,"<TR>");
				fprintf(fwants,"<TD>");
				fprintf(fwants,"%s - %s",last_die->race,last_die->name);
				fprintf(fwants,"</TD>");
				wants_column = !wants_column;
				if (wants_column)
					fprintf(fwants,"</TR>\n");
			}
			last_die = last_die->next;
		}
		if (!wants_column)
			fprintf(fwants,"<TD></TD></TR>\n");
		fprintf(fwants,"</TABLE>\n");
		fprintf(fwants,"</BODY></HTML>\n");
		fclose(fwants);
	}
	fclose(fin);
	fout = NULL;
	last_die = dice_list;
	strcpy_s(race,BUFFER_SIZE,"");
	size = 0;
	while (last_die != NULL) {
		dice *temp;

		pos = look_up(last_die->race,0,2);
		if (_strnicmp(pos,"Te",2) == 0) {
			strncpy_s(pos,LINE_SIZE,last_die->sort,9);
		}
		if (_stricmp(race,pos) != 0) {
			if (fout != NULL)  {
				fprintf(fout,"</TR></TABLE>\n");
				if (_strcmpi(return_race_short(race),"Te") == 0)
					fprintf(fout,"<CENTER>Click on the <A HREF=\"help.html\" TARGET=\"body\"><IMG SRC=\"images/view.gif\" ALT=\"help\"></A> above to get more information about each die.</CENTER><CENTER>Use positive numbers to get dice. Use negative numbers to give dice to me.</CENTER>");
				else
					bottom_of_page();
				fprintf(fout,"</FORM>\n</BODY>\n</HTML>\n");
				if (fshort != NULL) fprintf(fshort,"</TR></TABLE>\n");
				if (flist != NULL) fprintf(flist,"</TR></TABLE>\n");
				fclose(fout);
			}
			if (_strnicmp(pos,"Te",2) == 0) {
				strncpy_s(race,BUFFER_SIZE,last_die->sort,9);
			} else {
				strcpy_s(race,BUFFER_SIZE,pos);
			}
			strcpy_s(temp_str,LINE_SIZE,race);
			remove_junk(temp_str,LINE_SIZE);
			strcpy_s(line,LINE_SIZE,current_path);
			strcat_s(line,LINE_SIZE,temp_str);
			strcat_s(line,LINE_SIZE,".html");
			open_file(&fout,line,"wt","Can't open output file %s\n");
			fprintf(fout,header);
			if (output_form) fprintf(fout,"<FORM name=\"%s\" METHOD=\"POST\" ACTION=\"null\">",fix_name(race));
			fprintf(fout,"<TABLE BORDER=1 CELLSPACING=\"1\" CELLPADDING=\"1\" WIDTH=\"100%%\">\n");
			pos = look_up(last_die->race,9,2);
			if (_strnicmp(pos,"Te",2) == 0) {
				strncpy_s(title,BUFFER_SIZE,last_die->sort,9);
			} else {
				strcpy_s(title,BUFFER_SIZE,pos);
			}
			if (fshort != NULL) fprintf(fshort,"<P><A HREF=\"#directory\">Return to Directory</A>\n");
			pos2 = look_up(last_die->race,0,2);
			if (_strnicmp(pos2,"Te",2) == 0) {
				if (race[8] == '6') {
					strcpy_s(pos2,BUFFER_SIZE,"Minor Terrains");
				} else {
					strcpy_s(pos2,BUFFER_SIZE,"Terrains");
				}
				strcpy_s(line,BUFFER_SIZE,race);
			} else {
				strcpy_s(line,BUFFER_SIZE,pos2);
			}
			remove_junk(line,LINE_SIZE);
			if (fshort != NULL) fprintf(fshort,"<H3><A NAME=\"%s\">%s</A></H3>\n",line,pos2);
			if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 CELLSPACING=\"1\" CELLPADDING=\"1\" WIDTH=\"100%%\">\n");
			if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 CELLSPACING=\"1\" CELLPADDING=\"1\" WIDTH=\"100%%\">\n");
			if (_strnicmp(title,"ID",2) == 0)  {
				fprintf(fout,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
				if (fshort != NULL) fprintf(fshort,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
				if (flist != NULL) fprintf(flist,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
				for (temp = last_die,i = 0;i < 5;i++) {
					fprintf(fout,"<TH>%s</TH>\n",temp->type);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp->type);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp->type);
					temp = temp->next;
				}
			}
			if (_strnicmp(title,"EL",2) == 0)  {
				fprintf(fout,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
				if (fshort != NULL) fprintf(fshort,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
				if (flist != NULL) fprintf(flist,"<TR><TH></TH><TH COLSPAN=\"5\">%s</TH></TR><TR><TH></TH>\n",race);
			}
			else if (_strnicmp(title,"It",2) == 0) {
				fprintf(fout,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				if (fshort != NULL) fprintf(fshort,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				if (flist != NULL) fprintf(flist,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				for (temp = last_die,i = 0;i < 5;i++) {
					pos = strrchr(temp->race,'-') + 1;
					strcpy_s(temp_str,LINE_SIZE,pos);
					strcpy_s(color[i],COLOR_SIZE,temp_str);
					fprintf(fout,"<TH>%s</TH>\n",temp_str);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp_str);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp_str);
					temp = temp->next;
				}
			}
			else if (_strnicmp(title,"Dr",2) == 0) {
				fprintf(fout,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				if (fshort != NULL) fprintf(fshort,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				if (flist != NULL) fprintf(flist,"<TR><TH COLSPAN=\"2\">%s</TH>\n",race);
				temp = last_die;
				for (i = 0;i < 5;i++) {
					pos = strrchr(temp->race,'-') + 1;
					strcpy_s(temp_str,LINE_SIZE,pos);
					strcpy_s(color[i],COLOR_SIZE,temp_str);
					fprintf(fout,"<TH>%s</TH>\n",temp_str);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp_str);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp_str);
					temp = temp->next;
				}
			}
			else if (_strnicmp(title,"_D",2) == 0) {
				fprintf(fout,"<TR><TH>Dragons</TH>\n");
				if (fshort != NULL) fprintf(fshort,"<TR><TH>Dragons</TH>\n");
				if (flist != NULL) fprintf(flist,"<TR><TH>Dragons</TH>\n");
				temp = last_die;
				for (i = 0;(i < 24) && (strncmp(temp->name,"Drake",5) == 0);i++) {
					strcpy_s(temp_str,LINE_SIZE,temp->sort);
					pos = strrchr(temp_str,'-') + 1;
					strcpy_s(color[i],COLOR_SIZE,pos);
					fprintf(fout,"<TH>%s</TH>\n",pos);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",pos);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",pos);
					temp = temp->next;
				}
				for(;i < 24;i++)
					strcpy_s(color[i],COLOR_SIZE,"");
			}
			else if (_strnicmp(title,"Terrains6",9) == 0){
				fprintf(fout,"<TR><TH></TH>");
				fprintf(fout,"<TH COLSPAN=\"7\">Minor Terrains</TH></TR>\n");
				fprintf(fout,"<TR ALIGN=CENTER><TH></TH>\n");
				if (fshort != NULL) {
					fprintf(fshort,"<TR><TH></TH>");
					if (output_points) fprintf(fshort,"<TH></TH>");
					fprintf(fshort,"<TH COLSPAN=\"7\">Minor Terrains</TH></TR>\n");
					fprintf(fshort,"<TR ALIGN=CENTER><TH></TH>\n");
					if (output_points) fprintf(fshort,"<TH></TH>");
				}
				if (flist != NULL) {
					fprintf(flist,"<TR ALIGN=CENTER><TH>Minor Terrains</TH>\n");
				}
				for (temp = last_die,i = 0;i < 7;i++) {
					pos = look_up(temp->race,9,2);
					fprintf(fout,"<TH>%s</TH>\n",temp->race);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp->race);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp->race);
					temp = temp->next;
				}
			}
			else if (_strnicmp(title,"Terrains7",9) == 0){
				fprintf(fout,"<TR><TH></TH>");
				fprintf(fout,"<TH COLSPAN=\"6\">Terrains</TH></TR>\n");
				fprintf(fout,"<TR ALIGN=CENTER><TH></TH>\n");
				if (fshort != NULL) {
					fprintf(fshort,"<TR><TH></TH>");
					if (output_points) fprintf(fshort,"<TH></TH>");
					fprintf(fshort,"<TH COLSPAN=\"6\">Terrains</TH></TR>\n");
					fprintf(fshort,"<TR ALIGN=CENTER><TH></TH>\n");
					if (output_points) fprintf(fshort,"<TH></TH>");
				}
				if (flist != NULL) {
					fprintf(flist,"<TR ALIGN=CENTER><TH>Terrains</TH>\n");
				}
				for (temp = last_die,i = 0;i < 6;i++) {
					pos = look_up(temp->race,9,2);
					fprintf(fout,"<TH>%s</TH>\n",temp->race);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp->race);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp->race);
					temp = temp->next;
				}
			}
			else if (_strnicmp(title,"PR",2) == 0){
				fprintf(fout,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TH COLSPAN=\"11\">White Eldarim</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TH COLSPAN=\"6\">White Eldarim</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TH COLSPAN=\"6\">White Eldarim</TH></TR>\n<TR ALIGN=CENTER>\n");
				for (temp = last_die,i = 0;i < 11;i++) {
					strcpy_s(name,BUFFER_SIZE,temp->name);
					if ((pos = strchr(name,'(')) != NULL)  {
						*pos = '\0';
						strcpy_s(temp_str,LINE_SIZE,name);
						strcat_s(temp_str,LINE_SIZE,"<BR>");
						strcat_s(temp_str,LINE_SIZE,++pos);
						strcpy_s(name,BUFFER_SIZE,temp_str);
					}
					if (output_die_files)
						fprintf(fout,"<TD><A HREF=\"%s\" TARGET=\"body\">%s</A></TD>\n",temp->outname,name);
					else
						fprintf(fout,"<TD>%s</TD>\n",name);
					if (fshort != NULL) fprintf(fshort,"<TD>%s</TD>\n",name);
					if (flist != NULL) fprintf(flist,"<TD>%s</TD>\n",name);
					temp = temp->next;
				}
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				for (i = 0;i < 11;i++) {
					fprintf(fout,"<TD>");
					if (fshort != NULL) fprintf(fshort,"<TD>");
					if (flist != NULL) fprintf(flist,"<TD>");
					fprintf(fout,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (fshort != NULL) fprintf(fshort,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (flist != NULL) fprintf(flist,"%d",last_die->number);
					if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
					if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'P')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
					fprintf(fout,"</TD>\n");
					if (fshort != NULL)  {
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TD>\n");
					}
					if (flist != NULL) fprintf(flist,"</TD>");
					last_die = last_die->next;
				}
				fprintf(fout,"</TR>\n</TABLE>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n</TABLE>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n</TABLE>\n");
				fprintf(fout,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TH>Royalty Die</TH><TH COLSPAN=\"3\">Medallions</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TH>Royalty Die</TH><TH COLSPAN=\"3\">Medallions</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TH>Royalty Die</TH><TH COLSPAN=\"3\">Medallions</TH></TR>\n<TR ALIGN=CENTER>\n");
				for (temp = last_die,i = 0;i < 4;i++) {
					if (output_die_files)
						fprintf(fout,"<TH><A HREF=\"%s\" TARGET=\"body\">%s</A></TH>",temp->outname,temp->name);
					else
						fprintf(fout,"<TH>%s</TH>\n",temp->name);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp->name);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp->name);
					temp = temp->next;
				}
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				for (i = 0;i < 4;i++) {
					fprintf(fout,"<TD>");
					if (fshort != NULL) fprintf(fshort,"<TD>");
					if (flist != NULL) fprintf(flist,"<TD>");
					fprintf(fout,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (fshort != NULL) fprintf(fshort,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (flist != NULL) fprintf(flist,"%d",last_die->number);
					if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
					if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'p')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
					fprintf(fout,"</TD>\n");
					if (fshort != NULL)  {
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TD>\n");
					}
					if (flist != NULL) fprintf(flist,"</TD>");
					last_die = last_die->next;
				}
				continue;
			}
			else if (_strnicmp(title,"MI",2) == 0){
				fprintf(fout,"<TR><TH>%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				if (fshort != NULL) fprintf(fshort,"<TR><TH>%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				if (flist != NULL) fprintf(flist,"<TR><TH>%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				fprintf(fout,"<TD>");
				if (fshort != NULL) fprintf(fshort,"<TD>");
				if (flist != NULL) fprintf(flist,"<TD>");
				if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
				fprintf(fout,"%s",last_die->name);
				if (output_die_files) fprintf(fout,"</A>");
				fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
				if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
				if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
				if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
				if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%5.2f,'c')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
				fprintf(fout,"</TD>\n");
				if (fshort != NULL)  {
					if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
					fprintf(fshort,"</TD>\n");
				}
				if (flist != NULL) fprintf(flist,"</TD>");
				last_die = last_die->next;
				fprintf(fout,"</TR>\n</TABLE>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n</TABLE>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n</TABLE>\n");
				fprintf(fout,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TH COLSPAN=\"2\">%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				if (fshort != NULL) fprintf(fshort,"<TH COLSPAN=\"2\">%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				if (flist != NULL) fprintf(flist,"<TH COLSPAN=\"2\">%s</TH></TR>\n<TR ALIGN=CENTER>\n",last_die->race);
				for (i = 0;i < 2;i++) {
					fprintf(fout,"<TD>");
					if (fshort != NULL) fprintf(fshort,"<TD>");
					if (flist != NULL) fprintf(flist,"<TD>");
					if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
					fprintf(fout,"%s",last_die->name);
					if (output_die_files) fprintf(fout,"</A>");
					fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
					if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
					if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
					if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%5.2f,'X')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
					fprintf(fout,"</TD>\n");
					if (fshort != NULL)  {
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TD>\n");
					}
					if (flist != NULL) fprintf(flist,"</TD>");
					last_die = last_die->next;
				}
				fprintf(fout,"</TR>\n</TABLE>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n</TABLE>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n</TABLE>\n");
				fprintf(fout,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TH COLSPAN=\"4\">No Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TH COLSPAN=\"4\">No Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TH COLSPAN=\"4\">No Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				for (i = 0;i < 4;i++) {
					fprintf(fout,"<TD>");
					if (fshort != NULL) fprintf(fshort,"<TD>");
					if (flist != NULL) fprintf(flist,"<TD>");
					if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
					fprintf(fout,"%s",last_die->name);
					if (output_die_files) fprintf(fout,"</A>");
					fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
					if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
					if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
					if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%5.2f,'X')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
					fprintf(fout,"</TD>\n");
					if (fshort != NULL)  {
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TD>\n");
					}
					if (flist != NULL) fprintf(flist,"</TD>");
					last_die = last_die->next;
				}
				fprintf(fout,"</TR>\n</TABLE>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n</TABLE>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n</TABLE>\n");
				fprintf(fout,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TABLE BORDER=1 WIDTH=\"100%%\">\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TH COLSPAN=\"4\">Two Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"<TH COLSPAN=\"4\">Two Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"<TH COLSPAN=\"4\">Two Headed Mutant Goblins</TH></TR>\n<TR ALIGN=CENTER>\n");
				for (i = 0;i < 4;i++) {
					fprintf(fout,"<TD>");
					if (fshort != NULL) fprintf(fshort,"<TD>");
					if (flist != NULL) fprintf(flist,"<TD>");
					if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
					fprintf(fout,"%s",last_die->name);
					if (output_die_files) fprintf(fout,"</A>");
					fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
					if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
					if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
					if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
					if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%5.2f,'X')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size));
					fprintf(fout,"</TD>\n");
					if (fshort != NULL)  {
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TD>\n");
					}
					if (flist != NULL) fprintf(flist,"</TD>");
					last_die = last_die->next;
				}
				continue;
			}
		}
		if (size != last_die->size) {
			size = last_die->size;
			if (_strnicmp(title,"ID",2) == 0) {
				fprintf(fout,"</TR>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n");
				if (size == 4)  {
					fprintf(fout,"</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
					if (fshort != NULL) fprintf(fshort,"</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
					if (flist != NULL) fprintf(flist,"</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
				}
				fprintf(fout,"<TR ALIGN=CENTER>\n<TH>%s</TH>\n",size_string(size,last_die->sides));
				if (fshort != NULL) fprintf(fshort,"<TR ALIGN=CENTER>\n<TH>%s</TH>\n",size_string(size,last_die->sides));
				if (flist != NULL) fprintf(flist,"<TR ALIGN=CENTER>\n<TH>%s</TH>\n",size_string(size,last_die->sides));
			}
			else if (_strnicmp(title,"EL",2) == 0) {
				sort = '0';
				if (size > 1) {
					fprintf(fout,"</TR>\n</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
					if (fshort != NULL) fprintf(fshort,"</TR>\n</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
					if (flist != NULL) fprintf(flist,"</TR>\n</TABLE>\n<TABLE BORDER=1 WIDTH=\"100%%\" >\n");
				}
				if (size != 4) {
					fprintf(fout,"<TR ALIGN=CENTER><TH></TH>\n");
					if (fshort != NULL) fprintf(fshort,"<TR ALIGN=CENTER><TH></TH>\n");
					if (flist != NULL) fprintf(flist,"<TR ALIGN=CENTER><TH></TH>\n");
					for (temp = last_die,i = 0;i < (6u - size);i++) {
						fprintf(fout,"<TH>%s</TH>\n",temp->type);
						if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",temp->type);
						if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",temp->type);
						pos = temp->type;
						do {
							temp = temp->next;
						} while (_stricmp(temp->type,pos) == 0);
					}
					fprintf(fout,"</TR>\n");
					if (fshort != NULL) fprintf(fshort,"</TR>\n");
					if (flist != NULL) fprintf(flist,"</TR>\n");
				}
				fprintf(fout,"<TR ALIGN=CENTER>\n<TH ROWSPAN=\"%d\">%s</TH>\n",5-size,size_string(size,last_die->sides));
				if (fshort != NULL) fprintf(fshort,"<TR ALIGN=CENTER>\n<TH ROWSPAN=\"%d\">%s</TH>\n",5-size,size_string(size,last_die->sides));
				if (flist != NULL) fprintf(flist,"<TR ALIGN=CENTER>\n<TH ROWSPAN=\"%d\">%s</TH>\n",5-size,size_string(size,last_die->sides));
			}
			else if (_strnicmp(title,"It",2) == 0){
				strcpy_s(name,BUFFER_SIZE,"");
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				if (size == 4)  {
					fprintf(fout,"<TH ROWSPAN=\"6\">Artifacts</TH>\n");
					if (fshort != NULL)  {
						fprintf(fshort,"<TH ROWSPAN=\"5\">Artifacts");
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TH>\n");
					}
					if (flist != NULL)  {
						fprintf(flist,"<TH ROWSPAN=\"5\">Artifacts");
						fprintf(flist,"</TH>\n");
					}
					fprintf(fout,"<TD></TD>\n");
					for (temp = last_die,i = 0;i < 5;i++) {
						pos = strrchr(temp->race,'-') + 1;
						fprintf(fout,"<TH>%s</TH>\n",pos);
						temp = temp->next;
					}
					fprintf(fout,"</TR><TR ALIGN=CENTER>\n");
				}
				else {
					fprintf(fout,"<TH ROWSPAN=\"%d\">%s</TH>\n",((size == 1) ? 5 : 6),size_string(size,last_die->sides));
					if (fshort != NULL)  {
						fprintf(fshort,"<TH ROWSPAN=\"5\">%s",size_string(size,last_die->sides));
						if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
						fprintf(fshort,"</TH>\n");
					}
					if (flist != NULL) fprintf(flist,"<TH ROWSPAN=\"5\">%s",size_string(size,last_die->sides));
					if (flist != NULL) fprintf(flist,"</TH>");
					if (size != 1) {
						fprintf(fout,"<TD></TD>\n");
						for (temp = last_die,i = 0;i < 5;i++) {
							pos = strrchr(temp->race,'-') + 1;
							fprintf(fout,"<TH>%s</TH>\n",pos);
							temp = temp->next;
						}
						fprintf(fout,"</TR><TR ALIGN=CENTER>\n");
					}
				}
			}
			else if (_strnicmp(title,"Dr",2) == 0){
				strcpy_s(name,BUFFER_SIZE,"");
					while( i < 5) {
						fprintf(fout,"<TD>Don't Exist</TD>\n");
						if (fshort != NULL) fprintf(fshort,"<TD>Don't Exist</TD>\n");
						if (flist != NULL) fprintf(flist,"<TD>Don't Exist</TD>\n");
						i++;
					}
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				if (size == 4)  {
					fprintf(fout,"<TH ROWSPAN=\"3\">Champion</TH>\n");
					if (fshort != NULL) fprintf(fshort,"<TH ROWSPAN=\"3\">Champion</TH>\n");
					if (flist != NULL) fprintf(flist,"<TH ROWSPAN=\"3\">Champion</TH>\n");
				}
				else {
					fprintf(fout,"<TH ROWSPAN=\"%d\">%s</TH>\n",((size == 1) ? 3 : 4),size_string(size,last_die->sides));
					if (fshort != NULL) fprintf(fshort,"<TH ROWSPAN=\"3\">%s</TH>\n",size_string(size,last_die->sides));
					if (flist != NULL) fprintf(flist,"<TH ROWSPAN=\"3\">%s</TH>\n",size_string(size,last_die->sides));
					if (size != 1) {
						fprintf(fout,"<TD></TD>\n");
						for (i = 0;i < 5;i++) {
							fprintf(fout,"<TH>%s</TH>\n",color[i]);
						}
						fprintf(fout,"</TR><TR ALIGN=CENTER>\n");
					}
				}
			}
			else if (_strnicmp(title,"_D",2) == 0){
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
			}
//			else if ((_strnicmp(title,"Te",2) == 0) && (size == 7)) {
//				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n<TD></TD>");
//				for (temp = last_die,i = 0;i < 6;i++) {
//					pos = look_up(temp->race,9,2);
//					fprintf(fout,"<TH>");
//					if (output_faces) fprintf(fout,"<IMG SRC=\"images/view.gif\" ALT=\"%s\"><BR>",color[0]);
//					fprintf(fout,"%s</TH>\n",temp->race);
//					temp = temp->next;
//				}
//				strcpy_s(name,BUFFER_SIZE,"");
//			}
		}
		if	(_strnicmp(title,"It",2) == 0)  {
			if (_stricmp(name,last_die->name) != 0) {
				if (strlen(name) > 0)  {
					fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
					if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
					if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				}
				strcpy_s(name,BUFFER_SIZE,last_die->name);
				fprintf(fout,"<TD>");
				if (fshort != NULL) fprintf(fshort,"<TD>");
				if (flist != NULL) fprintf(flist,"<TD>");
				if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
				fprintf(fout,"%s",name);
				if (output_die_files) fprintf(fout,"</A>");
				fprintf(fout,"</TD>\n");
				if (fshort != NULL) fprintf(fshort,"\n%s</TD>\n",name);
				if (flist != NULL) fprintf(flist,"\n%s</TD>\n",name);
			}
			fprintf(fout,"<TD><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			pos = strrchr(last_die->race,'-') + 1;
			strcpy_s(temp_str,LINE_SIZE,pos);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s_%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'%c')\">",temp_str,fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),toupper(size_code(last_die->size)));
			fprintf(fout,"</TD>\n");
			if (fshort != NULL) fprintf(fshort,"<TD><FONT COLOR=\"%s\">%s</FONT></TD>\n",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (flist != NULL) fprintf(flist,"<TD>%d</TD>\n",last_die->number);
		}
		else if (_strnicmp(title,"Dr",2) == 0)  {
			if (_stricmp(name,last_die->name) != 0) {
				if (strlen(name) > 0)  {
					while( i < 5) {
						fprintf(fout,"<TD>Don't Exist</TD>\n");
						if (fshort != NULL) fprintf(fshort,"<TD>Don't Exist</TD>\n");
						if (flist != NULL) fprintf(flist,"<TD>Don't Exist</TD>\n");
						i++;
					}
					fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
					if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
					if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				}
				strcpy_s(name,BUFFER_SIZE,last_die->name);
				fprintf(fout,"<TD>");
				if (fshort != NULL) fprintf(fshort,"<TD>");
				if (flist != NULL) fprintf(flist,"<TD>");
				if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
				fprintf(fout,"%s",name);
				if (output_die_files) fprintf(fout,"</A>");
				fprintf(fout,"</TD>\n");
				if (fshort != NULL) fprintf(fshort,"%s</TD>\n",name);
				if (flist != NULL) fprintf(flist,"%s</TD>\n",name);
				i = 0;
			}
			pos = strrchr(last_die->race,'-') + 1;
			strcpy_s(temp_str,LINE_SIZE,pos);
			while (_stricmp(color[i++],temp_str) != 0)  {
				fprintf(fout,"<TD>Don't Exist</TD>\n");
				if (fshort != NULL) fprintf(fshort,"<TD>Don't Exist</TD>\n");
				if (flist != NULL) fprintf(flist,"<TD>Don't Exist</TD>\n");
			}
			fprintf(fout,"<TD><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s_%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'%c')\">",temp_str,fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),size_code(last_die->size));
			fprintf(fout,"</TD>\n");
			if (fshort != NULL) {
				fprintf(fshort,"<TD><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
				if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
				fprintf(fshort,"</TD>\n");
			}
			if (flist != NULL) {
				fprintf(flist,"<TD>%d",last_die->number);
				fprintf(flist,"</TD>\n");
			}
		}
		else if (_strnicmp(title,"_D",2) == 0)  {
			if ((hybrid == 0) && (strchr(last_die->sort,'z'))) {
				hybrid = 1;
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TR><TH>Hybrid Dragons</TH>\n");
				if (fshort != NULL) fprintf(fshort,"<TR><TH>Hybrid Dragons</TH>\n");
				if (flist != NULL) fprintf(flist,"<TR><TH>Hybrid Dragons</TH>\n");
				temp = last_die;
				for (i = 0;(i < 24) && (strncmp(temp->name,"Drake",5) == 0);i++) {
					strcpy_s(temp_str,LINE_SIZE,temp->sort);
					pos = strrchr(temp_str,'-') + 1;
					strcpy_s(color[i],COLOR_SIZE,pos);
					fprintf(fout,"<TH>%s</TH>\n",pos);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",pos);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",pos);
					temp = temp->next;
				}
				for (;i < 24;i++) {
					strcpy_s(color[i],COLOR_SIZE,"");
				}
			}
			if ((ivory_hybrid == 0) && (strchr(last_die->sort,'x'))) {
				ivory_hybrid = 1;
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				fprintf(fout,"<TR><TH>Ivory Hybrid Dragons</TH>\n");
				if (fshort != NULL) fprintf(fshort,"<TR><TH>Ivory Hybrid Dragons</TH>\n");
				if (flist != NULL) fprintf(flist,"<TR><TH>Ivory Hybrid Dragons</TH>\n");
				temp = last_die;
				for (i = 0;(i < 24) && (strncmp(temp->name,"Drake",5) == 0);i++) {
					strcpy_s(temp_str,LINE_SIZE,temp->sort);
					pos = strrchr(temp_str,'-') + 1;
					strcpy_s(color[i],COLOR_SIZE,pos);
					fprintf(fout,"<TH>%s</TH>\n",pos);
					if (fshort != NULL) fprintf(fshort,"<TH>%s</TH>\n",pos);
					if (flist != NULL) fprintf(flist,"<TH>%s</TH>\n",pos);
					temp = temp->next;
				}
				for (;i < 24;i++) {
					strcpy_s(color[i],COLOR_SIZE,"");
				}
			}
			if (_stricmp(name,last_die->name) != 0) {
				if (strlen(name) > 0)  {
					while ((i < 24) && (strlen(color[i]) > 0)) {
						fprintf(fout,"<TD>Don't Exist</TD>\n");
						if (fshort != NULL) fprintf(fshort,"<TD>Don't Exist</TD>\n");
						if (flist != NULL) fprintf(flist,"<TD>Don't Exist</TD>\n");
						i++;
					}
					fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
					if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
					if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
				}
				strcpy_s(name,BUFFER_SIZE,last_die->name);
				fprintf(fout,"<TD>");
				if (fshort != NULL) fprintf(fshort,"<TD>");
				if (flist != NULL) fprintf(flist,"<TD>");
				if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
				fprintf(fout,"%s",name);
				if (output_die_files) fprintf(fout,"</A>");
				fprintf(fout,"</TD>\n");
				if (fshort != NULL) fprintf(fshort,"%s</TD>\n",name);
				if (flist != NULL) fprintf(flist,"%s</TD>\n",name);
				i = 0;
			}
			strcpy_s(temp_str,LINE_SIZE,last_die->sort);
			pos = strrchr(temp_str,'-') + 1;
			while (_stricmp(color[i++],pos) != 0)  {
				fprintf(fout,"<TD>Don't Exist</TD>\n");
				if (fshort != NULL) fprintf(fshort,"<TD>Don't Exist</TD>\n");
				if (flist != NULL) fprintf(flist,"<TD>Don't Exist</TD>\n");
			}
			fprintf(fout,"<TD><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s_%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'%c')\">",temp_str,fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),size_code(last_die->size));
			fprintf(fout,"</TD>\n");
			if (fshort != NULL) {
				fprintf(fshort,"<TD><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
				if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
				fprintf(fshort,"</TD>\n");
			}
			if (flist != NULL) {
				fprintf(flist,"<TD>%d",last_die->number);
				fprintf(flist,"</TD>\n");
			}
		}
		else if (_strnicmp(title,"Te",2) == 0)  {
			if (_stricmp(name,last_die->type) != 0) {
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>\n");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>\n");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>\n");
			 	strcpy_s(name,BUFFER_SIZE,last_die->type);
				if (output_faces) {
					strcpy_s(temp_str,LINE_SIZE,last_die->faces);
					if (temp_str[0] == '(')  {
						strcpy_s(temp_str,LINE_SIZE,&temp_str[1]);
						pos = strchr(temp_str,')');
						*pos = '\0';
					}
				}
				fprintf(fout,"<TH ALIGN=LEFT>");
				if (fshort != NULL) fprintf(fshort,"<TH ALIGN=LEFT>");
				if (flist != NULL) fprintf(flist,"<TH ALIGN=LEFT>");
//				if (output_faces) fprintf(fout,"<IMG SRC=\"images/view.gif\" ALT=\"%s\"> ",temp_str);
				fprintf(fout,"%s</TH>",name);
				fprintf(fout,"\n");
				if (fshort != NULL)  {
					fprintf(fshort,"%s</TH>",name);
					if (output_points) fprintf(fshort,"<TD>%d pts</TD>",last_die->trade_points);
					fprintf(fshort,"\n");
				}
				if (flist != NULL)  {
					fprintf(flist,"%s</TH>",name);
					fprintf(flist,"\n");
				}
			}
			fprintf(fout,"<TD>");
			if (fshort != NULL) fprintf(fshort,"<TD>");
			if (flist != NULL) fprintf(flist,"<TD>");
			if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
			if (output_faces) fprintf(fout,"<IMG SRC=\"images/view.gif\" ALT=\"%s\">",look_up(last_die->name,9,2));
			if (output_die_files) fprintf(fout,"</A>");
			if (output_faces) fprintf(fout,"<BR>\n");
			fprintf(fout,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%5.2f,'%c')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),((last_die->size == 6) ? 't' : 'T'));
			if (fshort != NULL) fprintf(fshort,"<FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (flist != NULL) fprintf(flist,"%d",last_die->number);
			fprintf(fout,"</TD>\n");
			if (fshort != NULL) fprintf(fshort,"</TD>\n");
			if (flist != NULL) fprintf(flist,"</TD>\n");
		}
		else if (_strnicmp(title,"EL",2) == 0)  {
			if (sort != last_die->sort[4]) {
				fprintf(fout,"</TR>\n<TR ALIGN=CENTER>");
				if (fshort != NULL) fprintf(fshort,"</TR>\n<TR ALIGN=CENTER>");
				if (flist != NULL) fprintf(flist,"</TR>\n<TR ALIGN=CENTER>");
				sort = last_die->sort[4];
			}
			fprintf(fout,"<TD>");
			if (fshort != NULL) fprintf(fshort,"<TD>");
			if (flist != NULL) fprintf(flist,"<TD>");
			if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
			fprintf(fout,"%s",last_die->name);
			if (output_die_files) fprintf(fout,"</A>");
			fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
			if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'%c')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),size_code(last_die->size));
			fprintf(fout,"</TD>\n");
			if (fshort != NULL)  {
				if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
				fprintf(fshort,"</TD>\n");
			}
			if (flist != NULL) fprintf(flist,"</TD>\n");
		}
		else  {
			fprintf(fout,"<TD>");
			if (fshort != NULL) fprintf(fshort,"<TD>");
			if (flist != NULL) fprintf(flist,"<TD>");
			if (output_die_files) fprintf(fout,"<A HREF=\"%s\" TARGET=\"body\">",last_die->outname);
			fprintf(fout,"%s",last_die->name);
			if (output_die_files) fprintf(fout,"</A>");
			fprintf(fout,"<BR><FONT COLOR=\"%s\">%s</FONT>",trade_color(last_die->extra),extra_convert(last_die->extra));
			if (fshort != NULL) fprintf(fshort,"%s<BR><FONT COLOR=\"%s\">%s</FONT>",last_die->name,trade_color(last_die->extra),extra_convert(last_die->extra));
			if (flist != NULL) fprintf(flist,"%s<BR>%d",last_die->name,last_die->number);
			if (output_points) fprintf(fout,"<BR>%d pts",last_die->trade_points);
			if (output_form && last_die->extra) fprintf(fout,"<BR><input name=\"%s\" TYPE=text SIZE=\"4\" onChange=\"parent.parent.doTotal(this,%d,%d,%d,%4.2f,'%c')\">",fix_name(last_die->name),last_die->trade_points,last_die->extra,last_die->threshold,weight(last_die->size),size_code(last_die->size));
			fprintf(fout,"</TD>\n");
			if (fshort != NULL)  {
				if (output_points) fprintf(fshort,"<BR>%d pts",last_die->trade_points);
				fprintf(fshort,"</TD>\n");
			}
			if (flist != NULL) fprintf(flist,"</TD>\n");
		}
		last_die = last_die->next;
	}
	fprintf(fout,"</TR></TABLE>\n");
	if (_strcmpi(return_race_short(race),"Te") == 0) {
 		fprintf(fout,"<CENTER>Click on the <A HREF=\"help.html\" TARGET=\"body\"><IMG SRC=\"images/view.gif\" ALT=\"help\"></A> above to get more information about each die.</CENTER><CENTER>Use positive numbers to get dice. Use negative numbers to give dice to me.</CENTER>");
	}
	else
		bottom_of_page();
	fprintf(fout,"</FORM>\n</BODY>\n</HTML>\n");
	fclose(fout);
	if (fshort != NULL) {
		fprintf(fshort,"</TR></TABLE>\n</BODY>\n</HTML>\n");
		fclose(fshort);
	}
	if (flist != NULL) {
		fprintf(flist,"</TR></TABLE>\n</BODY>\n</HTML>\n");
		fclose(flist);
	}
	fprintf(ferr,"No Errors\n");
	fclose(ferr);
	return(0);
}